#!/usr/bin/python
import threading
import champFT
import gtk
import common
import numpy as np
import time
import struct
import socket
import copy
import os

from os import O_WRONLY, O_TRUNC, O_CREAT
from stat import S_IRUSR, S_IWUSR, S_IRGRP, S_IWGRP

#####################################################################
# now using numpy
# numarray fromstring(datastring, type, shape=None)
# numpy fromstring(string, dtype=float, count=-1, sep='')
# numarray na.Float32
# numpy np.float32
#####################################################################


class sMessage:
    def __init__(self):
    	self.typ = 0
	self.length = 0
	self.data = ''

class socketThread(threading.Thread):
    def __init__(self, name='TestThread'):
        """ constructor, setting initial variables """
        self._stopevent = threading.Event()
        self._sleepperiod = 0.4
        threading.Thread.__init__(self, name=name)
	self.smessage = sMessage()

    def initSocket(self):
        self.sock = None     
        for res in socket.getaddrinfo(common.host, common.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def readFlux(self):
        #numberOfFrames = 42 (number of flux measurements within one scan)
        #MAXCOMBOS = 12 (12 channels for 6 baselines)
        #FTMEMORY = ???? (History size)
        
        print "Read Fringe"
	length = common.nbpxFringe * 4 * common.nbFringe
        self.smessage.length = length
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFlux = 0
        else:
            self.flagSockFlux = 1
            self.sock.settimeout(30)
            #self.sock.send('RD')
            self.sock.send('HF')
            self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.fringeArr = np.fromstring(data, np.float32, (common.nbpxFringe*common.nbFringe)).reshape((common.nbpxFringe, common.nbFringe))

    def readPhase(self):
	length = common.nbpxFringe * 4 * common.nbFringe
        self.smessage.length = length
        #read phases
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockPhase = 0
        else:
            self.flagSockPhase = 1
            self.sock.settimeout(30)
            self.sock.send('RD')
            self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.phaseArr = np.fromstring(data, np.float32, (common.nbpxFringe*common.nbFringe)).reshape((common.nbpxFringe, common.nbFringe))

    def readJitter(self):
	length = common.nbpxFringe * 4 * common.nbFringe
        self.smessage.length = length
        #read phase jitter
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockJitter = 0
        else:
            self.flagSockJitter = 1
            self.sock.settimeout(30)
            self.sock.send('RD')
            self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.jitterArr = np.fromstring(data, np.float32, (common.nbpxFringe*common.nbFringe)).reshape((common.nbpxFringe, common.nbFringe))

    def run(self):
        """ main control loop """
        print "%s starts" % (self.getName(),)
        while not self._stopevent.isSet():
            self.readFlux()
            self.readPhase()
            self.readJitter()
            if self.flagSockFlux:   common.dataFluxReady = 1
            if self.flagSockPhase:  common.dataPhaseReady = 1
            if self.flagSockJitter: common.dataJitterReady = 1
	    self._stopevent.wait(self._sleepperiod)
        print "%s ends" % (self.getName(),)
        
    def join(self, timeout=None):                                                                          
        """ Stop the thread. """
        self._stopevent.set()
        threading.Thread.join(self, timeout)


def main():
    #create a thread
    sockThread = socketThread()
    # starts the thread
    sockThread.start()   
    gtk.gdk.threads_init()
    #starts the gui
    champFT.ApplicationMainWindow()
    gtk.main()
    # stops the thread
    sockThread.join()

if __name__ == "__main__":
    main()

