#!/usr/bin/python
import threading
import champFT
import gtk
import common
import numpy as np
import time
import struct
import socket
import copy
import os

from os import O_WRONLY, O_TRUNC, O_CREAT
from stat import S_IRUSR, S_IWUSR, S_IRGRP, S_IWGRP

#####################################################################
# now using numpy
# numarray fromstring(datastring, type, shape=None)
# numpy fromstring(string, dtype=float, count=-1, sep='')
# numarray na.Float32
# numpy np.float32
#####################################################################


class sMessage:
    def __init__(self):
    	self.typ = 0
	self.length = 0
	self.data = ''

class socketThread(threading.Thread):
    def __init__(self, name='TestThread'):
        """ constructor, setting initial variables """
        self._stopevent = threading.Event()
        self._sleepperiod = 0.4
        threading.Thread.__init__(self, name=name)
	self.smessage = sMessage()

    def initSocket(self):
        self.sock = None     
        for res in socket.getaddrinfo(common.host, common.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def readFlux(self):   #request flux of most current scan
        print "Read Flux"
	self.smessage.length = common.numberOfFrames * common.MAXCOMBOS * 4
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFlux = 0
        else:
            self.flagSockFlux = 1
            self.sock.settimeout(30)
            self.sock.send('FX')
            self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.fluxArr = np.fromstring(data, np.float32, (common.MAXCOMBOS*common.numberOfFrames)).reshape((common.MAXCOMBOS, common.numberOfFrames))

    def readFluxHist(self):   #request flux history: (1) send current frame number, (2) receive frame number & data
        #(1) receive number of current scan; (2) request new scans; (3) receive new scans
        print "Read Flux History"
        #read fringes
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockFlux = 0
        else:
            ArrTmp=np.zeros((common.MAXCOMBOS, common.FTMEMORY), dtype=np.float32)
                
            self.smessage.length = 4
            self.flagSockFlux = 1
            self.sock.settimeout(30)
            print "*** Send HF"
            self.sock.send('HF')

            #receive the number of the current scan nr
            print "*** Request New Scan Nr"
            self.sock.send(struct.pack('L', self.smessage.length))
            self.smessage.data = self.sock.recv(self.smessage.length)
            data = self.smessage.data
            common.fluxHistArrScanNrNew = np.fromstring(data, np.uint32, 1).reshape(1)
            print "*** Receive ScanNrNew:"
            print common.fluxHistArrScanNrNew

            print "(ScanNrCurr)"
            print common.fluxHistArrScanNrCurr

            reqScanNr = (common.fluxHistArrScanNrNew - common.fluxHistArrScanNrCurr)
            reqScanNr = 10
            if (reqScanNr>common.FTMEMORY): reqScanNr = common.FTMEMORY

            #request the new frames
            print "*** Request new frames:", reqScanNr
            print 
            self.smessage.length = reqScanNr * common.MAXCOMBOS * 4
            print self.smessage.length
            self.sock.send(struct.pack('L', self.smessage.length))

            #print "Length:"
            #print len(self.smessage.data)

            if (reqScanNr > 0):
                print "*** Waiting for new data:"
                length = 0
                data = ''
                print "*** HERE0"
                while length < self.smessage.length:
                    self.smessage.data = self.sock.recv(self.smessage.length-length)
                    length += len(self.smessage.data)
                    data += self.smessage.data
                self.sock.close()
                print "*** HERE1"
                ArrTmp = np.fromstring(data, np.float32, (common.MAXCOMBOS*reqScanNr)).reshape((common.MAXCOMBOS, reqScanNr))
                print "*** HERE2"
                print ArrTmp
                #ArrTmp2 = np.append(common.fluxHistArr, ArrTmp)
                print "*** HERE3"
                #common.fluxHistArr = ArrTmp2
                print "*** HERE4"
                #print ArrTmp2

    def readPhase(self):
	length = common.nbpxFringe * 4 * common.nbFringe
        self.smessage.length = length
        #read phases
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockPhase = 0
        else:
            self.flagSockPhase = 1
            self.sock.settimeout(30)
            self.sock.send('RD')
            self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.phaseArr = np.fromstring(data, np.float32, (common.nbpxFringe*common.nbFringe)).reshape((common.nbpxFringe, common.nbFringe))

    def readJitter(self):
	length = common.nbpxFringe * 4 * common.nbFringe
        self.smessage.length = length
        #read phase jitter
        self.initSocket()
        if self.sock == None:
            print "socket frame failed to create"
            self.flagSockJitter = 0
        else:
            self.flagSockJitter = 1
            self.sock.settimeout(30)
            self.sock.send('RD')
            self.sock.send(struct.pack('L', self.smessage.length))
            length = 0
            data = ''
            while length < self.smessage.length:
                self.smessage.data = self.sock.recv(self.smessage.length-length)
                length += len(self.smessage.data)
                data += self.smessage.data
            self.sock.close()
            common.jitterArr = np.fromstring(data, np.float32, (common.nbpxFringe*common.nbFringe)).reshape((common.nbpxFringe, common.nbFringe))

    def run(self):
        """ main control loop """
        print "%s starts" % (self.getName(),)
        while not self._stopevent.isSet():
            #self.readFlux()
            self.readFluxHist()
            self.readPhase()
            self.readJitter()
            if self.flagSockFlux:   common.dataFluxReady = 1
            if self.flagSockPhase:  common.dataPhaseReady = 1
            if self.flagSockJitter: common.dataJitterReady = 1
	    self._stopevent.wait(self._sleepperiod)
                
        print "%s ends" % (self.getName(),)
        
    def join(self, timeout=None):                                                                          
        """ Stop the thread. """
        self._stopevent.set()
        threading.Thread.join(self, timeout)


def main():
    #create a thread
    sockThread = socketThread()
    # starts the thread
    sockThread.start()   
    gtk.gdk.threads_init()
    #starts the gui
    champFT.ApplicationMainWindow()
    gtk.main()
    # stops the thread
    sockThread.join()

if __name__ == "__main__":
    main()

