#!/usr/bin/python
# fm  FilterMotor controller
# 2006Feb12 JDM Initiation
#

'''Menu

This example demonstrates the use of various menu types in gtk.  It
demonstrates the new submenu navigation and scrolling menu features of
gtk 2.0.'''

import gtk
import time
import fm_defaults as fmd
import serial as serial

def create_menu(depth, length=5):
    if depth < 1:
        return None

    menu = gtk.Menu()
    group= None

    for i in range(length):
        menuitem = gtk.RadioMenuItem(group, 'item %2d - %d' % (depth, i))
        group = menuitem
        menu.add(menuitem)
        menuitem.show()
        if depth > 1:
            submenu = create_menu(depth - 1)
            menuitem.set_submenu(submenu)
    return menu


class fm(gtk.Window):
    def __init__(self, parent=None):
        # Create the toplevel window
        gtk.Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: gtk.main_quit())

        self.set_title('Filter Controller')
        #self.__class__.__name__)

        vbox = gtk.VBox()
        self.add(vbox)

        menubar = gtk.MenuBar()
        vbox.pack_start(menubar, expand=False)
################# SETUP MIRC #####################################
        menuitem = gtk.MenuItem('MIRC')
# based on create_menu call
        submenu=gtk.Menu()
        submenuitem=gtk.MenuItem('FilterWheel 1')
        submenu.add(submenuitem)
        submenuitem.show()   # what does this do?
#Next do 2nd level
        submenu2=gtk.Menu()
        group2=None
        for i in range(8):
            submenuitem2=gtk.MenuItem(fmd.mirc1[i])
            submenuitem2.connect("activate",self.movef_cb,'MIRC','1',i)
            group2=submenuitem2
            submenu2.add(submenuitem2)
            submenuitem2.show()
        
        submenuitem.set_submenu(submenu2)
# end create_menu
#        menuitem.set_submenu(submenu)
      
## Add Second Filtwheel
        # based on create_menu call
 
        submenuitem=gtk.MenuItem('FilterWheel 2')
        submenu.add(submenuitem)
        submenuitem.show()   # what does this do?
#Next do 2nd level
        submenu2=gtk.Menu()
        group2=None
        for i in range(8):
            submenuitem2=gtk.MenuItem(fmd.mirc2[i])
            submenuitem2.connect("activate",self.movef_cb,'MIRC','2',i)
            group2=submenuitem2
            submenu2.add(submenuitem2)
            submenuitem2.show()
         
        submenuitem.set_submenu(submenu2)
# end create_menu
#        menuitem.set_submenu(submenu)

        submenuitem=gtk.MenuItem(fmd.mirc_init)
        submenuitem.connect("activate",self.initf_cb,'MIRC')
        submenu.add(submenuitem)
        submenuitem.show()   # what does this do?

 #       menuitem.set_submenu(submenu)

        submenuitem=gtk.MenuItem(fmd.mirc_setup)
        submenuitem.connect("activate",self.setupf_cb,'MIRC')
        submenu.add(submenuitem)
        submenuitem.show()   # what does this do?

        menuitem.set_submenu(submenu)
        menubar.add(menuitem)

####################  END MIRC PULL DOWN MENU #######################

####################  END CHAMP PULL DOWN MENU #######################
        menuitem = gtk.MenuItem('CHAMP')
      #  menuitem.set_submenu(submenu)
        #menuitem.set_submenu('Later Dude')
        menuitem.set_right_justified(True)
        menubar.add(menuitem)
 ####################  END CHAMP PULL DOWN MENU #######################

## put in pull-down menu callbacks

        
        vbox2 = gtk.VBox(spacing=10)
        vbox2.set_border_width(10)
        vbox.pack_start(vbox2)
        
        table = gtk.Table(4, 4, False)
        table.set_row_spacings(10)
        table.set_col_spacings(20)
        vbox2.pack_start(table, False, False, 0)

   
        label = gtk.Label("MIRC")
        label.set_pattern('____________________________')
        table.attach(label, 0, 1, 1, 3)

        label = gtk.Label("CHAMP")
        label.set_pattern('____________________________')
        table.attach(label, 0, 1, 3, 5)

        label = gtk.Label("Filterwheel 1")
        label.set_pattern('____________________________')
        table.attach(label, 1, 2, 0, 1)

        label = gtk.Label("Filterwheel 2")
        label.set_pattern('____________________________')
        table.attach(label, 2, 3, 0, 1)

        label = gtk.Label("Status")
        label.set_pattern('____________________________')
        table.attach(label, 3, 4, 0, 1)

        label = gtk.Label("Undefined")
        label.set_use_underline(True)
        table.attach(label,1,2,1,2)
        self.id_mirc_currentfilter1 = label

        label = gtk.Label("0")
        label.set_use_underline(True)
        table.attach(label,1,2,2,3)
        self.id_mirc_currentpos1 = label

        label = gtk.Label("Undefined")
        label.set_use_underline(True)
        table.attach(label,2,3,1,2)
        self.id_mirc_currentfilter2 = label

        label = gtk.Label("0")
        label.set_use_underline(True)
        table.attach(label,2,3,2,3)
        self.id_mirc_currentpos2 = label

        label = gtk.Label(" ")
        label.set_use_underline(True)
        table.attach(label,3,4,1,3)
        self.id_mirc_status1 = label

        self.table=table
        combo_box = gtk.combo_box_new_text()
        combo_box.set_wrap_width(2)
        for i in range(50):
            combo_box.append_text('item - %d' % i)
        combo_box.set_active(0)
        vbox2.pack_start(combo_box)

        separator = gtk.HSeparator()
        vbox.pack_start(separator, expand=False)

        vbox2 = gtk.VBox(spacing=10)
        vbox2.set_border_width(10)
        vbox.pack_start(vbox2, expand=False)

        button = gtk.Button('close')
        button.connect('clicked', lambda button, w=self: w.destroy())
        vbox2.pack_start(button)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()

        self.show_all()

        self.newPosi = ['0', '0']
        self.initf_cb(0,"MIRC")
        
    def movef_cb(self,widget,cam,fwheel,pos):
        if (cam == "MIRC"):
                print "Addressing MIRC Camera, "
                if (fwheel == "1"):
                    print "Filterwheel 1, "
                    mirc_port = serial.Serial(fmd.mirc_port, 9600, 8, 'N', 1, timeout=60)
                    print "pos = ",pos
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_mirc_status1.set_text("Homing...")
			mirc_port.write("1GH+0.5\r\n")
			print mirc_port.readline()
			mirc_port.write("1LF\r\n")
			print mirc_port.readline()
			print mirc_port.readline()
			mirc_port.write("1PR\r\n")
			print mirc_port.readline()
			print mirc_port.read(13)
	                mirc_port.write("1PZ\r\n")
                        print mirc_port.readline()
			mirc_port.write("1PR\r\n")
		        print mirc_port.readline()	
			print mirc_port.read(13)

                        fmd.mirc_currentpos1= 0
                        fmd.mirc_currentfilter1= "HOME"
                        self.id_mirc_currentfilter1.set_text(fmd.mirc_currentfilter1)
                        self.id_mirc_currentpos1.set_text(str(fmd.mirc_currentpos1))
                        self.id_mirc_status1.set_text("")
                        # rest of code
                    if (pos > 0):
                        if pos == 7:                            
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="1D%s\r1G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
                            mirc_port.write(ser_string)
                            mirc_port.write("1LF\r\n")
                            print mirc_port.readline()
                            print mirc_port.readline()
                            mirc_port.write("1PR\r\n")
                            print mirc_port.readline()
                            print mirc_port.read(13)
			    mirc_port.write("1IS\r\n")
			    dummystring = mirc_port.readline()
			    print dummystring
			    self.id_mirc_status1.set_text( dummystring)
                        else:
                            print fmd.mirc1[pos]
                            ser_string="1D%s\r1G\r" % str(fmd.mirc_filter1[pos-1])
                            mirc_port.write(ser_string)
                            mirc_port.write("1LF\r\n")
                            print mirc_port.readline()

                            print mirc_port.readline()
			    mirc_port.write("1IS\r\n")	
#			    print mirc_port.readline()
			    dummystring = mirc_port.readline()
			    self.id_mirc_status1.set_text( dummystring)
			    print dummystring
                            mirc_port.write("1PR\r\n")
                            print mirc_port.readline()
                            print mirc_port.read(13)
                            
                            fmd.mirc_currentpos1 = fmd.mirc_filter1[pos-1]
                            fmd.mirc_currentfilter1=fmd.mirc1[pos]
                            self.id_mirc_currentfilter1.set_text(fmd.mirc_currentfilter1)
                            self.id_mirc_currentpos1.set_text(str(fmd.mirc_currentpos1))
                    mirc_port.close()
                            
                if (fwheel == "2"):
                    print "Filterwheel 2, "
                    mirc_port = serial.Serial(fmd.mirc_port, 9600, 8, 'N', 1, timeout=60)
                    if (pos == 0):
                        print '** HOMING **'
                        self.id_mirc_status1.set_text("Homing...")
                        mirc_port.write("2GH+0.5\r\n")
                        print mirc_port.readline()
                        mirc_port.write("2PZ\r\n")
                        print mirc_port.readline()

                        fmd.mirc_currentpos2= 0
                        fmd.mirc_currentfilter2= "HOME"
                        self.id_mirc_currentfilter2.set_text(fmd.mirc_currentfilter2)
                        self.id_mirc_currentpos2.set_text(str(fmd.mirc_currentpos2))
                        self.id_mirc_status1.set_text("")
                        # rest of code
                        
                    if (pos > 0):
                        print fmd.mirc2[pos]
                        if pos == 7:                            
                            self.on_interactive_dialog_clicked(fwheel)
                            print self.newPosi[int(fwheel)-1]
                            ser_string="2D%s\r2G\r" % self.newPosi[int(fwheel)-1]
                            print ser_string
                            mirc_port.write(ser_string)
                            mirc_port.write("2LF\r\n")
                            print mirc_port.readline()
                            print mirc_port.readline()
                            mirc_port.write("2PR\r\n")
                            print mirc_port.readline()
                            print mirc_port.read(13)
                        else:
                            ser_string="2D%s\r2G\r" % str(fmd.mirc_filter2[pos-1])
                            mirc_port.write(ser_string)
                            fmd.mirc_currentpos2 = fmd.mirc_filter2[pos-1]
                            fmd.mirc_currentfilter2=fmd.mirc2[pos]
                            self.id_mirc_currentfilter2.set_text(fmd.mirc_currentfilter2)
                            self.id_mirc_currentpos2.set_text(str(fmd.mirc_currentpos2))
                        
                    mirc_port.close()
                    
    def on_interactive_dialog_clicked(self, fwheel):
        name = "Filer wheel "+fwheel
        dialog = gtk.Dialog("Interactive Dialog", self, 0,
                (gtk.STOCK_OK, gtk.RESPONSE_OK,
                "QUIT", gtk.RESPONSE_CLOSE))

        hbox = gtk.HBox(False, 8)
        hbox.set_border_width(8)
        dialog.vbox.pack_start(hbox, False, False, 0)

        stock = gtk.image_new_from_stock(
                gtk.STOCK_DIALOG_QUESTION,
                gtk.ICON_SIZE_DIALOG)
        hbox.pack_start(stock, False, False, 0)

        table = gtk.Table(2, 2)
        table.set_row_spacings(4)
        table.set_col_spacings(4)
        hbox.pack_start(table, True, True, 0)

        label = gtk.Label("WFilter wheel 1")
        label.set_use_underline(True)
        table.attach(label, 0, 1, 0, 1)
        local_entry1 = gtk.Entry()
        local_entry1.set_text(self.newPosi[int(fwheel)-1])
        table.attach(local_entry1, 1, 2, 0, 1)
        label.set_mnemonic_widget(local_entry1)

        dialog.show_all()

        response = dialog.run()

        if response == gtk.RESPONSE_OK:
            self.newPosi[int(fwheel)-1] = local_entry1.get_text()
        dialog.destroy()

    def initf_cb(self,widget, cam):
        print "Initializing " , cam
        if (cam == "MIRC"):
            print "Filterwheel 1..."
            mirc_port = serial.Serial(fmd.mirc_port, 9600, 8, 'N', 1, timeout=60)
            mirc_port.write("1MN\r\n")
            print mirc_port.readline()
	    mirc_port.write("1MPA\r\n")
	    print mirc_port.readline()
            mirc_port.write("1SSD0\r\n")
	    print mirc_port.readline()
            mirc_port.write("1LD3\r\n")
            print mirc_port.readline()
            mirc_port.write("1A0.5\r\n")
            print mirc_port.readline()
            mirc_port.write("1V0.5\r\n")
            print mirc_port.readline()
            mirc_port.write("1FSA1\r\n")
            print mirc_port.readline()
            mirc_port.write("1OSB1\r\n")
            print mirc_port.readline()
            mirc_port.write("1OSC1\r\n")
            print mirc_port.readline()
            mirc_port.write("1GH+0.5\r\n")
            print mirc_port.readline()
	    mirc_port.write("1LF\r\n")
            print mirc_port.readline()
            print mirc_port.readline()
            mirc_port.write("1PR\r\n")
            print mirc_port.readline()
            print mirc_port.read(13) 
            mirc_port.write("1PZ\r\n")
            fmd.mirc_currentpos1=0
            print mirc_port.readline()
	    mirc_port.write("1PR\r\n")
	    print mirc_port.readline()
	    print mirc_port.read(13)
	     
            print "Filterwheel 2..."
            mirc_port.write("2MN\r\n")
            print mirc_port.readline()
            mirc_port.write("2LD3\r\n")
            print mirc_port.readline()
            mirc_port.write("2A0.5\r\n")
            print mirc_port.readline()
            mirc_port.write("2V0.5\r\n")
            print mirc_port.readline()
            mirc_port.write("2FSA1\r\n")
            print mirc_port.readline()
            mirc_port.write("2OSB1\r\n")
            print mirc_port.readline()
            mirc_port.write("2OSC1\r\n")
            print mirc_port.readline()
            mirc_port.write("2GH+0.5\r\n")
            print mirc_port.readline()
            mirc_port.write("2PZ\r\n")
            print mirc_port.readline()
            fmd.mirc_currentpos2=0
            mirc_port.close()

            
        
    def setupf_cb (self,widget, cam):
        print "Setup Parameters for %s\n" % cam
   
def main():
    f=fm()
    gtk.main()

if __name__ == '__main__':
    main()
