import socket
import common
import time
import struct
import numarray as na
import string

import os

from os import O_WRONLY, O_TRUNC, O_CREAT
from stat import S_IRUSR, S_IWUSR, S_IRGRP, S_IWGRP


## class sMessage:
##     def __init__(self):
##     	self.typ = 0
## 	self.length = 0
## 	self.data = ''
    
class mountControl:

    def __init__(self, portNumber, naxis):
        """ constructor, setting initial variables """
        self.host = common.nport
        self.port = portNumber
        self.naxis = naxis
##         print "self.host = ", self.host
##         print "self.port = ", self.port

    def initSocket(self):
        self.sock = None
##        print "self.host = ", self.host
##        print "self.port = ", self.port
##         for res in socket.getaddrinfo(self.host, self.port, socket.AF_UNSPEC, socket.SOCK_STREAM):
##             af, socktype, proto, canonname, sa = res
        for res in socket.getaddrinfo(self.host, self.port, socket.AF_INET, socket.SOCK_STREAM):
            af, socktype, proto, canonname, sa = res
            try:
                self.sock = socket.socket(af, socktype, proto)
                self.sock.settimeout(10)
            except socket.error, msg:
                self.sock = None
                continue
            try:
                self.sock.connect(sa)
                self.fd = self.sock.fileno()
            except socket.error, msg:
                print str(msg)
		self.sock.close()
                self.sock = None
                continue
            break
        if self.sock is None:
            print 'could not open socket'

    def renumber(self):
        self.initSocket()
        time.sleep(.2)
        if self.sock == None:
            print "socket failed to create"
        else:
            list_outbuf = [chr(0)]*6        
            list_outbuf[1] = chr(2)
        
            inbuf = chr(1)*6
            inbuf = ''
            outbuf = string.join(list_outbuf, '')
            self.sock.send(outbuf)
            print "sent outbuf"
##             time.sleep(2)
            length = 0
            while length < 200:
                try: message = self.sock.recv(200-length)
                except:
                    print "finished reading message"
                    break
                else:
                    length += len(message)
                    inbuf += message
		    print length
            self.sock.close()
            stages = length / (6*self.naxis)
            return stages

    def save_position(self, path, stages):
        try: pos = os.open(path, O_WRONLY | O_TRUNC | O_CREAT)
        except:
            print 'Please choose another file name'
            print 'Error with path', path
            return -1
        else:
            #set permitions
            os.chmod(path , S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP )
            for h in range(1, stages+1): #1, ..., stages
                for i in range(1, self.naxis+1):
                    position = self.absolute_position(h, i)
                    line = str(position)
                    os.write(pos, line+"\n")
            os.close(pos)
            print "Luminos positions have been saved to %s.\n"%path
            return 1

    def recall_position(self, path, stages):
        try: pos = open(path, 'r')
        except:
            print 'File name invalid'
            return -1
        else:
            for h in range(1, stages+1): #1, ..., stages
                for i in range(1, self.naxis+1):
                    line = pos.readline()
                    li = int(line)
                    self.move_absolute(h, i, li)
            pos.close()
            print 'Luminos stages have been moved to the positions specified by %s.\n' %path
            return 1

    def set_position(self, stage, axis, position):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
            device = self.naxis*stage-self.naxis+axis
            if device == 0:
                self.sock.close()
                print 'Please use save_position(filename) to save all axes postions to a file'
                return -1
            else:
                command = 45
                list_outbuf = [chr(0)]*6
                inbuf = ''
                list_outbuf[0] = chr(device)
                list_outbuf[1] = chr(command)
                output_data = struct.pack('l', position)
                list_outbuf[2:] = output_data
                outbuf = string.join(list_outbuf, '')
                self.sock.send(outbuf)
                time.sleep(.5)
                length = 0
                while length < 6:
                    try: message = self.sock.recv(6-length)
                    except:
                        print "finished reading message"
                        break
                    else:
                        length += len(message)
                        inbuf += message
                self.sock.close()
                if (inbuf[0],inbuf[1]) == (chr(0),chr(0)):
                    print 'Requested actuor did not reply'  
                    return -1
                input_data = inbuf[2:]
                returned_data = struct.unpack('l', input_data)[0]
                if inbuf[1] == chr(255):
                    print 'Requested position setting of stage %i and axis %i is out of range.'%(stage,axis)
                    return -1
                return 1

    def command(self, device, cmnd, data):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
            list_outbuf = [chr(0)]*6
            inbuf = ''
            list_outbuf[0] = chr(device)
            list_outbuf[1] = chr(cmnd)
            output_data = struct.pack('l', data)
            list_outbuf[2:] = output_data
            outbuf = string.join(list_outbuf, '')
            self.sock.send(outbuf)
##             time.sleep(.5)
            length = 0
            while length < 6:
                try: message = self.sock.recv(6-length)
                except:
                    print "finished reading message"
                    break
                else:
                    length += len(message)
                    inbuf += message
            self.sock.close()
##             for c in inbuf:
##                 print ord(c)

            if (inbuf[0],inbuf[1]) == (chr(0),chr(0)):
                print 'Requested actuator did not reply'  
                return -1
            input_data = inbuf[2:]
            returned_data = struct.unpack('l', input_data)[0]
            returned_device = struct.unpack('b', inbuf[0])[0]
            returned_command = struct.unpack('b', inbuf[1])[0]
            print 'Returned signal is: \n %i %i %li\n' %(returned_device,returned_command,returned_data)
            return 1
    
    def home(self, stage, axis):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
            list_outbuf = [chr(0)]*6
            list_outbuf[1] = chr(1)
            if stage != 0:
                if axis == 0:
                    for i in range(1, self.naxis+1):
                        inbuf = ''
                        list_outbuf[0] = chr(self.naxis*(stage - 1)+i)
                        outbuf = string.join(list_outbuf, '')
                        self.sock.send(outbuf)
                        time.sleep(1)
                        length = 0
                        while length < 6:
                            try: message = self.sock.recv(6-length)
                            except:
                                print "finished reading message"
                                break
                            else:
                                length += len(message)
                                inbuf += message
                    self.sock.close()         
                    return 1
                else:
                    list_outbuf[0] = chr(self.naxis*(stage-1)+axis)
            inbuf = ''
            outbuf = string.join(list_outbuf, '')
            self.sock.send(outbuf)
            time.sleep(1)
            length = 0
            while length < 6:
                try: message = self.sock.recv(6-length)
                except:
                    print "finished reading message"
                    break
                else:
                    length += len(message)
                    inbuf += message
            self.sock.close()
            return 1
            
    def absolute_position(self, stage, axis):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
            inbuf = ''
            list_outbuf = [chr(0)]*6
            list_outbuf[0] = chr(self.naxis*stage-self.naxis+axis)
            list_outbuf[1] = chr(60)
            outbuf = string.join(list_outbuf, '')

            self.sock.send(outbuf)
## JDM 2007Jul26 reduced sleep from 0.5 to 0.3 sec
            time.sleep(.3)
            length = 0
            while length < 6:
                try: message = self.sock.recv(6-length)
                except:
                    print "finished reading message"
                    break
                else:
                    length += len(message)
                    inbuf += message
            self.sock.close()
            if (inbuf[0],inbuf[1]) == (chr(0),chr(0)):
                print 'Requested actuor did not reply'  
                return -1
            input_data = inbuf[2:]
            returned_data = struct.unpack('l', input_data)[0]
            return returned_data

    def move_absolute(self, stage, axis, position):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
            inbuf = ''
            device = self.naxis*stage-self.naxis+axis
            command = 20
            list_outbuf = [chr(0)]*6
            list_outbuf[0] = chr(device)
            list_outbuf[1] = chr(command)
            output_data = struct.pack('l', position)
            list_outbuf[2:] = output_data
            outbuf = string.join(list_outbuf, '')

            self.sock.send(outbuf)
            #time.sleep(1)
            length = 0
            while length < 6:
                try: message = self.sock.recv(6-length)
                except:
                    print "finished reading message"
                    break
                else:
                    length += len(message)
                    inbuf += message

            self.sock.close()
            if (inbuf[0],inbuf[1]) == (chr(0),chr(0)):
                print 'Requested actuor did not reply'  
                return -1
            input_data = inbuf[2:]
            returned_data = struct.unpack('l', input_data)[0]
            if inbuf[1] == chr(255):
                print 'Requested position setting of stage %i and axis %i is out of range.'%(stage,axis)
                return -1
            return 1
        
    def move_relative(self, stage, axis, position):
        self.initSocket()
        if self.sock == None:
            print "socket failed to create"
        else:
            device = self.naxis*stage - self.naxis +axis
        
	    command = 21
            inbuf = ''
            list_outbuf = [chr(0)]*6
            list_outbuf[0] = chr(device)
            list_outbuf[1] = chr(command)
            output_data = struct.pack('l', position)
            list_outbuf[2:] = output_data
            outbuf = string.join(list_outbuf, '')

            self.sock.send(outbuf)
            #time.sleep(.05)
            length = 0
            while length < 6:
                try: message = self.sock.recv(6-length)
                except:
                    print "finished reading message"
                    break
                else:
                    length += len(message)
                    inbuf += message
            self.sock.close()
            if (inbuf[0],inbuf[1]) == (chr(0),chr(0)):
                print 'Requested actuor did not reply'  
                return -1
            input_data = inbuf[2:]
            returned_data = struct.unpack('l', input_data)[0]
            if inbuf[1] == chr(255):
                print 'Requested position setting of stage %i and axis %i is out of range.'%(stage,axis)
                return -1
            return 1

def main(host):
    mountControl(host)

if __name__ == '__main__':
    main(host)
